/*									TPFH Ralit virtuelle								*
 *											(ESIEA)										*
 ****************************************************************************************/
#include <windows.h>					// En-tte standart aux prog. Windows
#include <gl\gl.h>						// fonctions OpenGL
#include <gl\glaux.h>					// Librairie AUX
#include <math.h>

#define LARGEUR 500
#define HAUTEUR 500

GLint cube = 0;

void drawFloor()
{
		glColor4f(0.5f, 0.5f, 0.5f, 0.75f);
		glBegin(GL_QUADS);
			  glVertex3f(-4.0,  4.0, 0.0);
			  glVertex3f( 4.0,  4.0, 0.0);
			  glVertex3f( 4.0, -4.0, 0.0);
			  glVertex3f(-4.0, -4.0, 0.0);
		glEnd();
}

void SetLight()
{
        GLfloat ambientProperties[] = {0.7f, 0.7f, 0.7f, 1.0f};
        GLfloat diffuseProperties[] = {1.0f, 1.0f, 1.0f, 1.0f};
        GLfloat positionProperties[] = {5.0f, 0.0f, 0.0f, 0.0f};
        glLightfv( GL_LIGHT0, GL_AMBIENT, ambientProperties);
        glLightfv( GL_LIGHT0, GL_DIFFUSE, diffuseProperties);
        glLightfv( GL_LIGHT0, GL_POSITION, positionProperties);
        glEnable(GL_LIGHT0);
        glEnable(GL_LIGHTING);
}

void CALLBACK Main_part(void)
{
        GLfloat Rouge[] = {0.8f, 0.0f, 0.0f, 1.0f};
        GLfloat Vert[]  = {0.0f, 0.8f, 0.0f, 1.0f};
        GLfloat Bleu[]  = {0.0f, 0.0f, 0.8f, 1.0f};

        glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
        glDisable(GL_DEPTH_TEST);
			//on ne va pas dessiner dans le buffer-cran, mais dans les autres buffers
        glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);       
        glEnable(GL_STENCIL_TEST);     
        glStencilOp(GL_REPLACE, GL_REPLACE, GL_REPLACE);           
        glStencilFunc(GL_ALWAYS, 1, 0xffffffff);
			//Dessin de la surface rflchissante dans le stencil-buffer
        drawFloor();
			//on reactive le dessin  l'ecran
        glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);            
        glEnable(GL_DEPTH_TEST);
			//cela va dessiner uniquement dans les endroits du stencil-buffer qui sont  1
			//c.a.d. dans le miroir
        glStencilFunc(GL_EQUAL, 1, 0xffffffff);      
        glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
		glCullFace(GL_BACK);
        glPushMatrix(); 
					//on fait la symtrie par rapport  l'axe des Z
               glScalef(1.0, 1.0, -1.0);
					//les lumires aussi subissent la symtrie
               SetLight();
					//on dessine la scne qui va tre reflte
               glTranslatef(0.0f, 0.0f, 5.0f);
               glRotatef((80.0f), -0.5f, 0.3f, -0.8f);
               glRotatef((10.0f), 0.5f, -0.3f, 0.8f);
               SetLight();
               glCallList(cube);
        glPopMatrix();   
			//fin de la symtrie
			//on remet les lumires	et tout le reste
        SetLight();
		glCullFace(GL_FRONT);
        glDisable(GL_STENCIL_TEST);
			//on dessine le sol transparent
        glEnable(GL_BLEND); 
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);    
        glDisable(GL_LIGHTING);
        drawFloor();
        glEnable(GL_LIGHTING);
        glDisable(GL_BLEND);
			//puis le reste de la scne
        glPushMatrix();
               glTranslatef(0.0f, 0.0f, 5.0f);
               glRotatef((80.0f), -0.5f, 0.3f, -0.8f);
               glRotatef((10.0f), 0.5f, -0.3f, 0.8f);
               glCallList(cube);
        glPopMatrix();
		auxSwapBuffers();
}

void init()
{
		GLfloat Rouge[] = {0.8f, 0.0f, 0.0f, 1.0f};
		GLfloat Vert[]  = {0.0f, 0.8f, 0.0f, 1.0f};
		GLfloat Bleu[]  = {0.0f, 0.0f, 0.8f, 1.0f};
		GLfloat Jaune[]  = {0.8f, 0.8f, 0.0f, 1.0f};
		GLfloat Rose[]  = {0.8f, 0.0f, 0.8f, 1.0f};
		GLfloat	Cyan[]  = {0.0f, 0.8f, 0.8f, 1.0f};

		cube = glGenLists(1);
		glNewList(cube, GL_COMPILE);
			glBegin(GL_QUADS);
			   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Rouge);
			   glNormal3d(0.0,0.0,1.0);
			   glVertex3d(-1,  1, 1);
			   glVertex3d(-1, -1, 1);
			   glVertex3d( 1, -1, 1);
			   glVertex3d( 1,  1, 1);
			   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Jaune);
			   glNormal3d(-1.0,0.0,0.0);
			   glVertex3d( -1,  1,  1);
			   glVertex3d( -1,  1, -1);
			   glVertex3d( -1, -1, -1);
			   glVertex3d( -1, -1,  1);
			   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Vert);
			   glNormal3d(1.0,0.0,0.0);
			   glVertex3d( 1,  1,  1);
			   glVertex3d( 1, -1,  1);
			   glVertex3d( 1, -1, -1);
			   glVertex3d( 1,  1, -1);
			   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Rose);
			   glNormal3d(0.0,1.0,0.0);
			   glVertex3d( -1, 1,  1);
			   glVertex3d(  1, 1,  1);
			   glVertex3d(  1, 1, -1);
			   glVertex3d( -1, 1, -1);
			   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Bleu);
			   glNormal3d(0.0,-1.0,0.0);
			   glVertex3d( -1, -1,  1);
			   glVertex3d( -1, -1, -1);
			   glVertex3d(  1, -1, -1);
			   glVertex3d(  1, -1,  1);
			   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Cyan);
			   glNormal3d(0.0,0.0,-1.0);
			   glVertex3d(  1,  1, -1);
			   glVertex3d(  1, -1, -1);
			   glVertex3d( -1, -1, -1);
			   glVertex3d( -1,  1, -1);		   
			glEnd();
		glEndList();
}

void CALLBACK reshape (int width, int height)
{
      glViewport (0, 0, width, height);
      glMatrixMode (GL_PROJECTION);
      glLoadIdentity ();
	  gluPerspective (45.0, ((GLfloat) width) / ((GLfloat) height),1.0,100.0);
      glMatrixMode (GL_MODELVIEW);
      glLoadIdentity ();
      gluLookAt (0.0,-7.0,15.0, 0.0, 0.0, 0.0,0.0,0.0, 1.0);
      glEnable(GL_DEPTH_TEST);
      glEnable(GL_POLYGON_SMOOTH);
      SetLight();
}

int main (int argc, char *argv[])
{
		auxInitDisplayMode(AUX_DOUBLE | AUX_RGBA | AUX_DEPTH | AUX_STENCIL);
		auxInitPosition(100,100,LARGEUR,HAUTEUR); 
		auxInitWindow("Reflet");
		auxReshapeFunc(reshape);
		init();
		auxMainLoop(Main_part);
		return 0;
}
